/*
    Dirty Quick Hack from : "rb.interpol2d v26/07/2012 -  Roald Baudoux"
*/

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

#include "ext.h"
#include "ext_obex.h"
#include "ext_systhread.h"

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

#define MAXSIZE     256
#define NUM_INLETS  5

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

typedef struct _flop {				
	t_object	ob;
    int			inited;
    long		list1_length;
    long		list2_length;
    long		list3_length;
    long		list4_length;
    long		min_length;
	t_atom		pos2d[2];
    t_atom		temp_atom[MAXSIZE];
	t_atom		input_list1[MAXSIZE];
	t_atom		input_list2[MAXSIZE];
	t_atom		input_list3[MAXSIZE];
	t_atom		input_list4[MAXSIZE];
	t_atom		output_list[MAXSIZE];
	void		*outlet;
    void		*proxy[NUM_INLETS];
    } t_flop;

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
    
void *flop_new              (t_symbol *s, long argc, t_atom *argv);
void flop_free              (t_flop *x);
void flop_list              (t_flop *x, t_symbol *s, long ac, t_atom *av);
void all_lists_inited_test  (t_flop *x);

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

t_class *flop_class;

int main(void)
{
	t_class *c;

	c = class_new("flop", (method)flop_new, (method)flop_free, sizeof(t_flop), 0L, A_GIMME, 0);
	class_addmethod(c, (method)flop_list, "list", A_GIMME, 0);
	class_register(CLASS_BOX, c);
	flop_class = c;

	return 0;
}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void *flop_new(t_symbol *s, long argc, t_atom *argv)
{
	t_flop *x;

	if (x = (t_flop *)object_alloc(flop_class)) {
        int i;
        
        for (i = NUM_INLETS -1 ; i >= 1; i--) {
            x->proxy[i] = proxy_new(x, i, 0L);	
        }

        x->outlet = listout((t_object *)x);
	}

	return(x);
}

void flop_free(t_flop *x)
{
    int i;
    
    for (i = NUM_INLETS - 1; i >= 1; i--) {
        object_free(x->proxy[i]);
    }
}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void flop_list(t_flop *x, t_symbol *s, long ac, t_atom *av)
{
    int i;
 	double partie1;
	double partie2;
	double partie3;
	double partie4;
    long inlet = proxy_getinlet((t_object *)x);
    
	for (i = 0; i < ac; i++) {
		switch(atom_gettype(av + i)){
			case A_FLOAT:
				atom_setfloat(&x->temp_atom[i], atom_getfloat(av + i));
				break;
			case A_LONG:
				atom_setfloat(&x->temp_atom[i], atom_getlong(av + i));
				break;
		}
	}

	switch (inlet) {
    //
    case 0: 
        if (ac == 2) {
            for(i=0;i<ac;++i) //clipping between 0. and 1.
            {
                x->pos2d[i] = x->temp_atom[i];
                if (x->pos2d[i].a_w.w_float > 1.) {
                    atom_setfloat(x->pos2d+i, 1.0);
                } else if (x->pos2d[i].a_w.w_float < 0.) {
                    atom_setfloat(x->pos2d+i, 0.0);
                }
            }
        } else post ("List in first inlet should have 2 items rather than %d.\n", ac);
        break;
    case 1:
        x->list1_length = ac;
        all_lists_inited_test(x);
        for(i=0;i<ac;++i)
        {
            x->input_list1[i].a_w.w_float = x->temp_atom[i].a_w.w_float;
        }

        break;
    case 2:
        x->list2_length = ac;
        all_lists_inited_test(x);
        for(i=0;i<ac;++i)
        {
            x->input_list2[i].a_w.w_float = x->temp_atom[i].a_w.w_float;
        }

        break;
    case 3:
        x->list3_length = ac;
        all_lists_inited_test(x);
        for(i=0;i<ac;++i)
        {
            x->input_list3[i].a_w.w_float = x->temp_atom[i].a_w.w_float;
        }

        break;
    case 4:
        x->list4_length = ac;
        all_lists_inited_test(x);
        for(i=0;i<ac;++i)
        {
            x->input_list4[i].a_w.w_float = x->temp_atom[i].a_w.w_float;
        }

        break;
    //
	}

	if (x->inited == 1) {
		for(i=0;i<x->min_length;++i)
		{
			partie1 = (1. - (x->pos2d[0].a_w.w_float)) * (x->input_list1[i].a_w.w_float);
		    partie2 = (x->pos2d[0].a_w.w_float) * (x->input_list2[i].a_w.w_float);
			partie1 = partie1 + partie2;
			partie1 = (1. - (x->pos2d[1].a_w.w_float)) * partie1;
			partie3 = (1. - (x->pos2d[0].a_w.w_float)) * (x->input_list3[i].a_w.w_float);
			partie4 = (x->pos2d[0].a_w.w_float) * (x->input_list4[i].a_w.w_float);
			partie3 = partie3+partie4;
		    partie3 = (x->pos2d[1].a_w.w_float) * partie3;
			partie1 = partie1+partie3;
			atom_setfloat(x->output_list+i, partie1);
		}
		outlet_list(x->outlet, s, x->min_length, x->output_list);
	};
}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void all_lists_inited_test(t_flop *x) {
	if (x->list1_length != 0 && x->list2_length != 0 && x->list3_length != 0 && x->list4_length)
	{
		x->inited = 1;
		x->min_length = x->list1_length;
		if (x->list2_length < x->min_length) x->min_length = x->list2_length;
		if (x->list3_length < x->min_length) x->min_length = x->list3_length;
		if (x->list4_length < x->min_length) x->min_length = x->list4_length;
	}
}